SystemOrganization addCategory: 'OrbeonBPMRuntime_Tests'!

TestCase subclass: #BpmProcessExecutionTest
	instanceVariableNames: 'procInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/20/2015 13:30'!
createFormInstance: xmlMethodName definitionNamed: definitionName app: app
	"The receiver create anOrbeonFormInstance of form definition named <definitionName> of Orbeon Applicaiton named <app> using the method <xmlMethodName> to get the XML string of the form "
	| application definition |

	application := OrbeonApplication applicationNamed: app.
	definition := application definitionNamed: definitionName.

	^(OrbeonFormInstance app: app form: definitionName id: UUID new asString)
			definition: definition;
			xmlString: (OrbeonFormTemplate perform: xmlMethodName);
			processXML;
			yourself! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 13:29'!
executeArtifact: aBpmTaskInstance withForm: aOrbeonFormInstance
	"The receiver execute and finalize the artifact <anArtifactInstance> associated with the form <aOrbeonFormInstance> "

	^self executeArtifact: aBpmTaskInstance withForm: aOrbeonFormInstance on: procInstance! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/01/2015 13:28'!
executeArtifact: aBpmTaskInstance withForm: aOrbeonFormInstance on: aBpmProcessInstance
	"The receiver execute and finalize the artifact <anArtifactInstance> associated with the form <aOrbeonFormInstance> "

	aBpmTaskInstance formInstance: aOrbeonFormInstance.
	aBpmProcessInstance finalizeTask: aBpmTaskInstance.

	^aBpmTaskInstance! !

!BpmProcessExecutionTest methodsFor: 'Accessing' stamp: 'BrunoBB 11/17/2015 11:34'!
procInstance
	^procInstance! !

!BpmProcessExecutionTest methodsFor: 'Updating' stamp: 'BrunoBB 11/17/2015 11:34'!
procInstance: newValue
	procInstance := newValue! !

BpmProcessExecutionTest subclass: #BugTrackerProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:08'!
formInstance_analyzeDeveloperReportNo

	^self createFormInstance: #form_analyzeDeveloperReportNo definitionNamed: 'analyze-developer-report' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:08'!
formInstance_analyzeDeveloperReportYes

	^self createFormInstance: #form_analyzeDeveloperReportYes definitionNamed: 'analyze-developer-report' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:48'!
formInstance_analyzeIssueNo

	^self createFormInstance: #form_analyzeIssueNo definitionNamed: 'analyze-issue' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:46'!
formInstance_analyzeIssueReportAccept

	^self createFormInstance: #form_analyzeIssueReportAccept definitionNamed: 'analyze-issue-report' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:47'!
formInstance_analyzeIssueReportReject

	^self createFormInstance: #form_analyzeIssueReportReject definitionNamed: 'analyze-issue-report' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:48'!
formInstance_analyzeIssueYes

	^self createFormInstance: #form_analyzeIssueYes definitionNamed: 'analyze-issue' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:44'!
formInstance_executeTestFailed

	^self createFormInstance: #form_executeTestFailed definitionNamed: 'execute-test' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:44'!
formInstance_executeTestPassed

	^self createFormInstance: #form_executeTestPassed definitionNamed: 'execute-test' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:06'!
formInstance_internalTest

	^self createFormInstance: #form_internalTest definitionNamed: 'internal-test' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:06'!
formInstance_reportFixes

	^self createFormInstance: #form_reportFixes definitionNamed: 'report-fixes' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:09'!
formInstance_reportSolution

	^self createFormInstance: #form_reportSolution definitionNamed: 'report-solution' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:08'!
formInstance_reportWorkaround

	^self createFormInstance: #form_reportWorkaround definitionNamed: 'report-workaround' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:43'!
formInstance_testCase

	^self createFormInstance: #form_analyzeData1 definitionNamed: 'test-case' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:45'!
formInstance_testOk

	^self createFormInstance: #form_testOk definitionNamed: 'test-ok' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 14:18'!
setUp
	| procDefinition processGenerator |

	processGenerator := BpmProcessGenerator exampleTestCaseFixIssueReportArchitect.

	procDefinition := processGenerator getProcessDefinitionNamed: 'test-case-process' ifNone: [self assert: false].

	procInstance := procDefinition createProcessInstance: nil. "the process is create by an anonynous user"

	procDefinition addProcessInstance: procInstance.! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/28/2015 19:43'!
tearDown

	procInstance definition removeProcessInstance: procInstance! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 15:11'!
testExecutionTestExecutionFailedRejectIssue
	| currentTask nextTasks gateway endArtifact |

	procInstance triggerStartEvent.
	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := self executeArtifact: procInstance currentActivities last withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := self executeArtifact: nextTasks last withForm: self formInstance_executeTestFailed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := self executeArtifact: gateway outTransitions last endArtifact withForm: self formInstance_analyzeIssueReportReject.
	self assert: (currentTask getDefinitionName = 'analyze-issue-report').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'accept-issue').

	endArtifact := gateway outTransitions last endArtifact.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 15:15'!
testExecutionTestExecutionOk
	| currentTask nextTasks gateway endArtifact |

	procInstance triggerStartEvent.
	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := self executeArtifact: procInstance currentActivities last withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := self executeArtifact: nextTasks last withForm: self formInstance_executeTestPassed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := self executeArtifact: gateway outTransitions last endArtifact withForm: self formInstance_testOk.
	self assert: (currentTask getDefinitionName = 'test-ok').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/02/2015 12:22'!
testExecutionTestExecutionSubProcessL1
	"Execute the subprocess only to one level (inmediate childs of the top process)"
	| currentTask nextTasks gateway endArtifact subProcess subProcessArtifact |

	procInstance triggerStartEvent.
	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := self executeArtifact: procInstance currentActivities last withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := self executeArtifact: nextTasks last withForm: self formInstance_executeTestFailed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := self executeArtifact: gateway outTransitions last endArtifact withForm: self formInstance_analyzeIssueReportAccept.
	self assert: (currentTask getDefinitionName = 'analyze-issue-report').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'accept-issue').

	subProcessArtifact := gateway outTransitions last endArtifact.
	subProcess := subProcessArtifact processInstance.
"------------------ Sub Process Execution Starts here -------------------------------"
	self assert:  subProcess isSubProcess.
	self assert: (subProcess startEvent getDefinitionName = 'start').

	currentTask := self executeArtifact: subProcess currentActivities last withForm: self formInstance_analyzeIssueYes on: subProcess.
	self assert: (currentTask getDefinitionName = 'analyze-issue').

	gateway := (subProcess generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'can fix').

	currentTask := self executeArtifact: gateway outTransitions last endArtifact withForm: self formInstance_reportFixes on: subProcess.
	self assert: (currentTask getDefinitionName = 'report-fixes').

	nextTasks := (subProcess generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := self executeArtifact: nextTasks last withForm: self formInstance_internalTest on: subProcess.
	self assert: (currentTask getDefinitionName = 'internal-test').

	endArtifact := (subProcess generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).
"------------------ Sub Process Execution Ends here -------------------------------"
"------------------ Parent Process Execution Starts here -------------------------------"
	currentTask := self executeArtifact: procInstance currentActivities last withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := self executeArtifact: nextTasks last withForm: self formInstance_executeTestPassed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := self executeArtifact: gateway outTransitions last endArtifact withForm: self formInstance_testOk.
	self assert: (currentTask getDefinitionName = 'test-ok').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/02/2015 13:19'!
testExecutionTestExecutionSubProcessL2
	"Execute the subprocess only to two level "
	| currentTask nextTasks gateway endArtifact subProcessL1 subProcessArtifactL1 subProcessL2 subProcessArtifactL2 |

	procInstance triggerStartEvent.
	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := self executeArtifact: procInstance currentActivities last withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := self executeArtifact: nextTasks last withForm: self formInstance_executeTestFailed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := self executeArtifact: gateway outTransitions last endArtifact withForm: self formInstance_analyzeIssueReportAccept.
	self assert: (currentTask getDefinitionName = 'analyze-issue-report').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'accept-issue').

	subProcessArtifactL1 := gateway outTransitions last endArtifact.
	subProcessL1 := subProcessArtifactL1 processInstance.
	"------------------ Sub Process Execution Starts here L1-------------------------------"
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start').

		currentTask := self executeArtifact: subProcessL1 currentActivities last withForm: self formInstance_analyzeIssueNo on: subProcessL1.
		self assert: (currentTask getDefinitionName = 'analyze-issue').

		gateway := (subProcessL1 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
		gateway := gateway last.
		self assert: (gateway getDefinitionName = 'can fix').

		subProcessArtifactL2 := gateway outTransitions last endArtifact.
		subProcessL2 := subProcessArtifactL2 processInstance.
	"------------------ Sub Process Execution Ends here L1-------------------------------"
		"------------------ Sub Process Execution Starts here L2-------------------------------"
			self assert:  subProcessL2 isSubProcess.
			self assert: (subProcessL2 startEvent getDefinitionName = 'start').

			currentTask := self executeArtifact: subProcessL2 currentActivities last withForm: self formInstance_analyzeDeveloperReportYes on: subProcessL2.
			self assert: (currentTask getDefinitionName = 'analyze-developer-report').

			gateway := (subProcessL2 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
			gateway := gateway last.
			self assert: (gateway getDefinitionName = 'has-solution').

			currentTask := self executeArtifact: gateway outTransitions last endArtifact withForm: self formInstance_reportSolution on: subProcessL2.
			self assert: (currentTask getDefinitionName = 'report-solution').

			endArtifact := (subProcessL2 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
			endArtifact := endArtifact last.
			self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).
		"------------------ Sub Process Execution Ends here L2-------------------------------"
	"------------------ Sub Process Execution Resume here L1-------------------------------"
		endArtifact := (subProcessL1 generateNextTransitionsFrom: subProcessL2 creatorTask) collect: [:each | each endArtifact].
		endArtifact := endArtifact last.
		self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).
	"------------------ Sub Process Execution End here L1-------------------------------"
"------------------ Parent Process Execution Starts here -------------------------------"
	currentTask := self executeArtifact: procInstance currentActivities last withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := self executeArtifact: nextTasks last withForm: self formInstance_executeTestPassed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := self executeArtifact: gateway outTransitions last endArtifact withForm: self formInstance_testOk.
	self assert: (currentTask getDefinitionName = 'test-ok').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).! !

BpmProcessExecutionTest subclass: #SmaltalksRegistrationExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:03'!
formInstance_acceptRegistration

	^self createFormInstance: #form_acceptRegistration definitionNamed: 'accept-registration' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:02'!
formInstance_analyzeData1

	^self createFormInstance: #form_analyzeData1 definitionNamed: 'analyze-data' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:02'!
formInstance_analyzeData2

	^self createFormInstance: #form_analyzeData2 definitionNamed: 'analyze-data' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 11:56'!
formInstance_registration

	^self createFormInstance: #form_registration definitionNamed: 'registration' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:04'!
formInstance_securityReport

	^self createFormInstance: #form_securityReport definitionNamed: 'security-report' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/28/2015 17:13'!
setUp
	| procDefinition processGenerator |

	processGenerator := BpmProcessGenerator exampleSmalltalksRegistration.

	procDefinition := processGenerator getProcessDefinitionNamed: 'registration' ifNone: [self assert: false].

	procInstance := procDefinition createProcessInstance: (BpmUser getUserNamed: 'alberto').

	procDefinition addProcessInstance: procInstance.! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/17/2015 12:01'!
tearDown

	procInstance definition removeProcessInstance: procInstance! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 14:11'!
testExecutionPathRegistrationAccepted
	| currentTask nextTasks gateway endArtifact |

	procInstance triggerStartEvent.
	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := self executeArtifact: procInstance currentActivities last withForm: self formInstance_registration.
	self assert: (currentTask getDefinitionName = 'registration').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := self executeArtifact: nextTasks last withForm: self formInstance_analyzeData1.
	self assert: (currentTask getDefinitionName = 'analyze-data').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'security-issue').

	currentTask := self executeArtifact: gateway outTransitions last endArtifact withForm: self formInstance_acceptRegistration.
	self assert: (currentTask getDefinitionName = 'accept-registration').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: (endArtifact getDefinitionName = 'end 1').

	^self assert: true! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/29/2015 14:13'!
testExecutionPathRegistrationRejected
	| currentTask nextTasks gateway endArtifact |

	procInstance triggerStartEvent.
	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := self executeArtifact: procInstance currentActivities last withForm: self formInstance_registration.
	self assert: (currentTask getDefinitionName = 'registration').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := self executeArtifact: nextTasks last withForm: self formInstance_analyzeData2.
	self assert: (currentTask getDefinitionName = 'analyze-data').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'security-issue').

	currentTask := self executeArtifact: gateway outTransitions last endArtifact withForm: self formInstance_securityReport.
	self assert: (currentTask getDefinitionName = 'security-report').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: (endArtifact getDefinitionName = 'end 2').! !
